/*
  
  Text Clustering  Copyright (C) 2004 Debora "Barbara" Donato, Antonio Gulli

  This library is free software; you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by 
  the Free Software Foundation; either version 2.1 of the License, or 
  (at your option) any later version.

  This library is distributed in the hope that it will be useful, but 
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
  License for more details.

  You should have received a copy of the GNU Lesser General Public License 
  along with this library; if not, write to the Free Software Foundation, Inc., 
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 

*/
#ifndef CLUSTERING
#define CLUSTERING 1

#include <string>
#include "dictionary.h"
#include "docvectors.h"

using namespace std;

/*
 * An abstract class for Clustering 
 *  any cluster algorithm shoudl derive this
 */
class Clustering{

 protected:
  unsigned long docID;                // current docID loaded

 public:
  virtual void initDataSet(void) = 0;
  virtual void loadInDataSet(string& s) = 0;
  virtual void finalizeLoadingDocument(void) = 0;

  virtual void do_clustering(void) = 0;

  // determines the k hash functions
  virtual void initialize(void) = 0;

  //  Clustering(){};
  //virtual ~Clustering() = 0;
};

#endif
