/*
  
  Text Clustering  Copyright (C) 2004 Debora "Barbara" Donato, Antonio Gulli

  This library is free software; you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by 
  the Free Software Foundation; either version 2.1 of the License, or 
  (at your option) any later version.

  This library is distributed in the hope that it will be useful, but 
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
  License for more details.

  You should have received a copy of the GNU Lesser General Public License 
  along with this library; if not, write to the Free Software Foundation, Inc., 
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 

*/
#ifndef READER
#define READER 1
#include <iostream>
#include <iterator>
#include "docvectors.h"
#include "dictionary.h"
#include "Clustering.h"
/*
 * An abstract class for reader  
 *  it loads a vector space
 */
class Reader{

 protected:
  vector<string> idToURL;                       // mantains an association docID to URL

 public:
  virtual void loadDataSet(Clustering * algo) = 0;
  
};


/*
 * Aa very simple reader
 *  it loads a vector space
 */
class simpleReader : public Reader{

 public:
  void loadDataSet(Clustering * algo);
};

#endif
