
/*
  
  Text Clustering  Copyright (C) 2004 Debora "Barbara" Donato, Antonio Gulli

  This library is free software; you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by 
  the Free Software Foundation; either version 2.1 of the License, or 
  (at your option) any later version.

  This library is distributed in the hope that it will be useful, but 
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
  License for more details.

  You should have received a copy of the GNU Lesser General Public License 
  along with this library; if not, write to the Free Software Foundation, Inc., 
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
*/

#ifndef _stringhash_hh_
#define _stringhash_hh_
 
#include <string.h>
 
#if __GNUC__ > 3 || (__GNUC__ == 3 && (__GNUC_MINOR__ >= 1))
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_map>
#endif
#include <string>
     
struct eqstr {
  bool operator()(const char *s1, const char *s2) {
    return strcmp(s1, s2) == 0;
  }
};

template<class storageT>
class string_map: public hash_map<const char *, storageT, hash<const char*>, eqstr> {};

#if __GNUC__ > 3 || (__GNUC__ == 3 && (__GNUC_MINOR__ >= 1))
namespace __gnu_cxx {
  
  struct hash<std::string> {
    size_t operator()(std::string &__s) const { return __stl_hash_string(__s.c_str()); }
  };
  
  struct hash<const std::string> {
    size_t operator()(const std::string &__s) const { return __stl_hash_string(__s.c_str()); }
  }; 
};
#else
struct hash<std::string> {
  size_t operator()(std::string &__s) const { return __stl_hash_string(__s.c_str()); }
};

struct hash<const std::string> {
  size_t operator()(const std::string &__s) const { return __stl_hash_string(__s.c_str()); }
};
#endif

#endif
